#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libpq-fe.h"

#define HOSTNAME "wonder"


int debug = 0;

int dosql(PGconn *dbh, char *sql);
int dosql(PGconn *dbh, char *sql)
{
  PGresult *res;
  int num;

  if (debug)
    fprintf(stderr,"%s\n",sql);

  if (!(res = PQexec(dbh, sql)) || PQresultStatus(res) != PGRES_COMMAND_OK)
  {
    fprintf(stderr,"Could not execute `%s': %s(%d)\n",sql, PQresStatus(PQresultStatus(res)),PQresultStatus(res));
    abort();
  }

  num = atoi(PQcmdTuples(res));
  PQclear(res);

  return(num);
}

int main(int argc, char *argv[])
{
  char buf[2048];
  char sql[2048];
  PGconn *dbh = NULL;
  char *foo = getenv("DEBUG");

  if (!foo)
    foo="0";

  debug = atoi(foo);

  dbh = PQsetdbLogin(HOSTNAME, NULL, NULL, NULL, NULL, NULL, NULL);

  if (!dbh)
    abort();

  switch(PQstatus(dbh))
  {
  case CONNECTION_OK:
    fprintf(stderr,"PQ status %d OK\n",PQstatus(dbh));
    break;
  case CONNECTION_BAD:
    fprintf(stderr,"PQ status %d BAD\n",PQstatus(dbh));
    break;
  case CONNECTION_STARTED:
    fprintf(stderr,"PQ status %d STARTED\n",PQstatus(dbh));
    break;
  case CONNECTION_MADE:
    fprintf(stderr,"PQ status %d MADE\n",PQstatus(dbh));
    break;
  case CONNECTION_AWAITING_RESPONSE:
    fprintf(stderr,"PQ status %d RESPONSE\n",PQstatus(dbh));
    break;
  case CONNECTION_AUTH_OK:
    fprintf(stderr,"PQ status %d AUTHOK\n",PQstatus(dbh));
    break;
  case CONNECTION_SETENV:
    fprintf(stderr,"PQ status %d SETENV\n",PQstatus(dbh));
    break;
  default:
    fprintf(stderr,"PQ status %d DEFAULT\n",PQstatus(dbh));
    break;
  }

  while (fgets(buf, sizeof(buf), stdin))
  {
    u_int32_t addr = (u_int32_t)atoll(buf);
    int num;
    char *ptr = (strchr(buf,' ') + 1);

    num = atoi(ptr);

    snprintf(sql,sizeof(sql),"UPDATE test SET accum = accum + %d WHERE val = %u;", num, addr);
    if (dosql(dbh,sql) < 1)
    {
      snprintf(sql,sizeof(sql),"INSERT INTO test VALUES (%u, %d);", addr, num);
      if (dosql(dbh,sql) < 1)
      {
	abort();
      }
    }
  }
  PQfinish(dbh);
  exit(0);
}
